require 'scim/query/filter/parser'
require 'test/unit'
require 'yaml'
require 'json'

class TestCase < Test::Unit::TestCase
  def test_case
    data = YAML.load $test_case_data
    parser = SCIM::Query::Filter::Parser.new
    data.each do |test_case|
      query = test_case['query']
      parser.parse query

      got_rpn_json = parser.rpn.to_json
      want_rpn_json = test_case['rpn'].to_json
      assert_equal want_rpn_json, got_rpn_json,
        "Test parse to RPN: '#{query}'"

      got_tree_json = parser.tree.to_json
      want_tree_json = test_case['tree'].to_json
      assert_equal want_tree_json, got_tree_json,
        "Test parse to tree: '#{query}'"
    end
  end
end

# See http://www.simplecloud.info/specs/draft-scim-api-01.html#query-resources
$test_case_data = <<'...'
- query: USERName eQ "Ingy döt Net"
  rpn:   [username,'"Ingy döt Net"',eq]
  tree:  [eq, username,'"Ingy döt Net"']
...
